package com.amqp.shanxi.service;

import com.amqp.shanxi.util.AMQPTopicStaticDataConfig;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AlarmDataAMQPService {

    @Autowired
    private AlarmDataService alarmDataService;

    @Autowired
    private SensorDataService sensorDataService;

    /**
     * 实时数据推送入口
     */
    public void run(Connection connection) {
        List<String> sensorKind = sensorDataService.findSensorKind();
        publishAlarm("device", connection);
        publishAlarm("wkk", connection);
        for (String kind : sensorKind) {
            if ("干滩".equals(kind)) {
                publishAlarm("gt", connection);
            } else if("库水位".equals(kind)) {
                publishAlarm("ksw", connection);
            }else if("坝体表面位移".equals(kind)) {
                publishAlarm("bmwy", connection);
            }else if("浸润线".equals(kind)) {
                publishAlarm("jrx", connection);
            }else if("雨量计".equals(kind)){
                publishAlarm("jyl", connection);
            }else if("内部位移".equals(kind)) {
                publishAlarm("nbwy", connection);
            }
        }
    }

    public void publishAlarm(String type, Connection connection) {
        try {
            if ("gt".equals(type)) {
                String gantanAlarmData = alarmDataService.gantanAlarm();
                if (gantanAlarmData.length() > 2) {
                    Channel channel = connection.createChannel();
                    // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                    channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                            , AMQPTopicStaticDataConfig.TOPICQUEUEGANtANALARM
                            , null
                            , gantanAlarmData.getBytes());
                    // 消息确认
                    channel.confirmSelect();
                    if (channel.waitForConfirms()) {
                        System.out.println("干滩报警信息发送成功！");
                    } else {
                        System.out.println("干滩报警信息发送失败！");
                    }
                    channel.close();
                } else {
                    System.out.println("暂无干滩报警信息数据～");
                }

            } else if ("ksw".equals(type)) {
                String kswAlarmData = alarmDataService.kushuiweiAlarm();
                if (kswAlarmData.length() > 2) {
                    Channel channel = connection.createChannel();
                    // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                    channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                            , AMQPTopicStaticDataConfig.TOPICQUEUEKUSHUIWEIALARM
                            , null
                            , kswAlarmData.getBytes());
                    //消息确认
                    channel.confirmSelect();
                    if (channel.waitForConfirms()) {
                        System.out.println("库水位报警信息发送成功！");
                    } else {
                        System.out.println("库水位报警信息发送失败！");
                    }
                    channel.close();
                } else {
                    System.out.println("暂无库水位报警信息数据～");
                }
            } else if ("bmwy".equals(type)) {
                String bmwyAlarmData = alarmDataService.biaomianweiyiAlarm();
                if (bmwyAlarmData.length() > 2) {
                    Channel channel = connection.createChannel();
                    // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                    channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                            , AMQPTopicStaticDataConfig.TOPICQUEUEBIAOMIANWEIYIALARM
                            , null
                            , bmwyAlarmData.getBytes());
                    //消息确认
                    channel.confirmSelect();
                    if (channel.waitForConfirms()) {
                        System.out.println("表面位移报警信息发送成功！");
                    } else {
                        System.out.println("表面位移报警信息发送失败！");
                    }
                    channel.close();
                }else {
                    System.out.println("暂无表面位移报警信息数据～");
                }
            } else if ("nbwy".equals(type)) {

                Channel channel = connection.createChannel();
                String nbcjAlarmData = alarmDataService.neibuchenjiangAlarm();
                String nbspAlarmData = alarmDataService.neibushuipingAlarm();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                if (nbspAlarmData.length() > 2) {
                    channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                            , AMQPTopicStaticDataConfig.TOPICQUEUENEIBUWEIYIALARM
                            , null
                            , nbspAlarmData.getBytes());
                    //消息确认
                    channel.confirmSelect();
                    if (channel.waitForConfirms()) {
                        System.out.println("内部水平报警信息发送成功！");
                    } else {
                        System.out.println("内部水平报警信息发送失败！");
                    }
                }else {
                    System.out.println("暂无内部水平报警信息数据～");
                }

                // ====================内部沉降
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                if (nbcjAlarmData.length() > 2) {
                    channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                            , AMQPTopicStaticDataConfig.TOPICQUEUENEIBUWEIYIALARM
                            , null
                            , nbcjAlarmData.getBytes());
                    //消息确认
                    channel.confirmSelect();
                    if (channel.waitForConfirms()) {
                        System.out.println("内部沉降报警信息发送成功！");
                    } else {
                        System.out.println("内部沉降报警信息发送失败！");
                    }
                }else {
                    System.out.println("暂无内部沉降报警信息数据～");
                }
                channel.close();
            } else if ("jrx".equals(type)) {
                String jrxAlarmData = alarmDataService.jinrunxianAlarm();
                if (jrxAlarmData.length() > 2) {
                    Channel channel = connection.createChannel();
                    // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                    channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                            , AMQPTopicStaticDataConfig.TOPICQUEUEJINRUNXIANALARM
                            , null
                            , jrxAlarmData.getBytes());
                    //消息确认
                    channel.confirmSelect();
                    if (channel.waitForConfirms()) {
                        System.out.println("浸润线报警信息发送成功！");
                    } else {
                        System.out.println("浸润线报警信息发送失败！");
                    }
                    channel.close();
                }else {
                    System.out.println("暂无浸润线报警信息数据～");
                }
            } else if ("jyl".equals(type)) {
                String jylAlarmData = alarmDataService.jiangyuliangAlarm();
                if (jylAlarmData.length() > 2) {
                    Channel channel = connection.createChannel();
                    // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                    channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                            , AMQPTopicStaticDataConfig.TOPICQUEUEJIANGYULIANGALARM
                            , null
                            , jylAlarmData.getBytes());
                    //消息确认
                    channel.confirmSelect();
                    if (channel.waitForConfirms()) {
                        System.out.println("降雨量报警信息发送成功！");
                    } else {
                        System.out.println("降雨量报警信息发送失败！");
                    }
                    channel.close();
                } else {
                    System.out.println("暂无降雨量报警信息数据～");
                }
            }/* else if ("sll".equals(type)) {

            }*/ else if ("device".equals(type)) {
                String deviceAlarmData = alarmDataService.deviceAlarm();
                if (deviceAlarmData.length() > 2) {
                    // 监测项数据信息
                    Channel channel = connection.createChannel();
                    // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                    channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                            , AMQPTopicStaticDataConfig.TOPICQUEUEDEVICEALARM
                            , null
                            , deviceAlarmData.getBytes());
                    //消息确认
                    channel.confirmSelect();
                    if (channel.waitForConfirms()) {
                        System.out.println("检测项报警信息发送成功！");
                    } else {
                        System.out.println("检测项报警信息发送失败！");
                    }
                    channel.close();
                }else {
                    System.out.println("暂无检测项报警信息数据～");
                }
            } else if ("wkk".equals(type)) {
                String wkkAlarmData = alarmDataService.wkkAlarm();
                if (wkkAlarmData.length() > 2) {
                    // 尾矿库数据信息
                    Channel channel = connection.createChannel();
                    // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                    channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                            , AMQPTopicStaticDataConfig.TOPICQUEUEWKKALARM
                            , null
                            , wkkAlarmData.getBytes());
                    //消息确认
                    channel.confirmSelect();
                    if (channel.waitForConfirms()) {
                        System.out.println("尾矿库报警信息发送成功！");
                    } else {
                        System.out.println("尾矿库报警信息发送失败！");
                    }
                    channel.close();
                }else {
                    System.out.println("暂无尾矿库报警信息数据～");
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
